/*
 
This code is shamelessly copied direct from the libsndfile examples and does
the bare minimum job, badly.

It works on 44khz 16bit stereo wav files. With anything else, your mileage may
vary.

*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <sndfile.h>
#include "cmdline.h"

#define BUFFER_LEN 4096


int main (int argc, char *argv[])
{
int data [BUFFER_LEN];
char *infilename;
SNDFILE	*infile;
SF_INFO	sfinfo;
unsigned int k, readcount, len, total;
unsigned long int i;
int amplitude;
int count, start, running;
// the volume at which fuzz becomes sound
int volthreshold;
// the minimum period of silence between two tracks
// beware: setting this to less than 2 will break some integer division
int intervaltime;

infilename = cmdline(argc, argv, &volthreshold, &intervaltime); 

if (!(infile = sf_open_read (infilename, &sfinfo)))
	{
	printf ("Not able to open input file %s.\n", infilename);
	sf_perror (NULL);
	return  1;
	}

fprintf(stderr, "\nVolume threshold: %d\nMinimum inter-track interval: %d\n\n", volthreshold, intervaltime);
		
len = BUFFER_LEN - (BUFFER_LEN % sfinfo.channels);
total = 0;
i = 0;
amplitude = 0;

count = 0;
start = 0;
running = 0;
while ((readcount = sf_read_int (infile, data, len)))
	{	
	for (k = 0; k < readcount; k++)
		{
		if (! (k % sfinfo.channels))
			{
			i++;
			if (amplitude < volthreshold)
				{
				count++;
				}
			else
				{
				if (count > sfinfo.samplerate * intervaltime)
					{
					if (running==0)
						{
						printf("%d ",  start/sfinfo.samplerate);
						running = 1;
						}
						printf("%d\n%d ", ((start+(sfinfo.samplerate*(intervaltime/2)))/sfinfo.samplerate), ((start+count)-(sfinfo.samplerate*(intervaltime/2)))/sfinfo.samplerate);
					}
				start = i;
				count = 0;
				}
			amplitude = 0;
			}
		else
			{
			amplitude+=data[k];
			}
		}
	memset (data, 0, (len*sizeof(int)));
	total += readcount;
	}
if (total != sfinfo.samples * sfinfo.channels)
	printf ("Error : Values read (%d) != samples * channels (%d)\n", total, sfinfo.samples * sfinfo.channels);

sf_close (infile);

printf("%d\n", (int)(i/sfinfo.samplerate));

return 0;
} /* main */

